#include "ros/ros.h"
#include <ros/package.h>
#include "asclinic_pkg/LeftRightInt32.h"
#include <fstream>

ros::Subscriber m_subscriber;
std::ofstream data_save_file

void Callback(const asclinic_pkg::LeftRightInt32& msg){
    ROS_INFO_STREAM("Received message - Left: " << msg.left << ", Right: " << msg.right << ", Seq_num: " << msg.seq_num);

    // Append received data to the CSV file
    if (data_save_file.is_open()) {
        data_save_file << msg.left << ", " << msg.right << ", " << msg.seq_num << std::endl;
    } else {
        ROS_ERROR_STREAM("File encoder_data.csv is not open for writing.");
    }
}

int main(int argc, char* argv[]){
    ros::init(argc, argv, "receive_encoder");
    ros::NodeHandle nh;

    // Subscribe to the "asc/encoder_counts" topic
    m_subscriber = nh.subscribe("asc/encoder_counts", 1, Callback);

    // Open or clear the CSV file
    outputFile.open("/home/asc/encoder_data.csv", std::ios::out | std::ios::trunc);
    if (!data_save_file.is_open()) {
        ROS_ERROR_STREAM("Unable to create/clear file encoder_data.csv");
        return 1; // Exit with error
    }

    // Write header to the file
    data_save_file << "Left, Right, Seq_num" << std::endl;

    ROS_INFO_STREAM("Node started");
    ros::spin();

    // Close the file before exiting
    data_save_file.close();
    return 0;
}

